=== debian/changelog ===
d1x-rebirth (0.57.3-1) unstable; urgency=low

  * Initial release (Closes: #576275).

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 25 May 2013 06:26:12 +1000
