=== debian/changelog ===
d1x-rebirth (0.58.1-1build1) bionic; urgency=high

  * No change rebuild to pick up -fPIE compiler default

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 03 Apr 2018 12:18:25 +0000

d1x-rebirth (0.58.1-1) unstable; urgency=low

  * New upstream release [July 2013].
  * Patchworks:
    - dropped "LDFLAGS.patch".
    + updated "debian.patch".

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 04 Aug 2013 06:24:09 +1000

d1x-rebirth (0.57.3-2) unstable; urgency=low

  * "XS-Autobuild: yes" + autobuild, thanks to Philipp Kern.
  * Corrected man page.
  * Removed non-existing package "d1x-rebirth-data-hires" from Recommends.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 04 Aug 2013 00:07:52 +1000
