=== debian/control ===
Source: d1x-rebirth
Section: non-free/games
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Standards-Version: 3.9.4
Build-Depends: debhelper (>= 9)
              ,imagemagick
              ,libphysfs-dev
              ,libsdl1.2-dev
              ,libsdl-mixer1.2-dev
              ,scons
XS-Autobuild: yes
Homepage: http://www.dxx-rebirth.com
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/onlyjob/d1x-rebirth.git
Vcs-Git: git://anonscm.debian.org/users/onlyjob/d1x-rebirth.git

Package: d1x-rebirth
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: timidity, freepats
Description: port of the 1995 classic game Descent 1: First Strike
 DXX-Rebirth is a Source Port of the Descent & Descent ][ Engines and
 provides classical Gameplay combined with OpenGL graphics and effects,
 a bunch of improvements and new features.
 .
 Original game data is needed to play this game.
